#include "stdafx.h"
#include "header.h"

int CMoveType::Purge (void)
{
    tName = "";
    mIcon = gfxLoad("!Null", "Root");
    
    return 0; // Done
};

int movetypeFind (string tToFind)
{
    // Finds a given movement type.
    
    for(int i = 0; i < giMaxMovetypes; i++)
    {
        if(movetype[i].tName == tToFind)
            return i; // Success
    };
    
    return -1; // Failure
};

int movetypeLoad (string tFile)
{
	// A routine for parsing movement type data from a file.
	
	FILE * pFile;					// A pointer to the file.
	string tInput;					// Input from the parser.
	
	// First, we need to make sure the file is actually there. In the future,
	// if it's missing, we fall back on the default ruleset data. For now, we
	// just boot the player. :3
	
	if(!exists(tFile.c_str()))
	{
		allegro_message("The movement type data that the engine needs appears to be missing.");
		exit(-1);
	}; //end if
	
	// Okay, let's start by clearing out major data. Everything else
	// we can pretty much clear as we go.
	
	giMovementSlotsUsed = 0;
    
	// We can now open the file...
	
	pFile = fopen(tFile.c_str(), "rt");
	
	// ...And begin parsing the data. We keep going until we hit the end of the file.
	
	while(!feof(pFile))
	{
		// First get the next command.
		
		tInput = parGet(pFile, ' ', '\n', ',');

		// CLASS
		
		if(tInput == "TYPE")
		{
			int iSlot = 0;				// The slot number this data will take.
			
            // Increase the total number of this kind of data availible by one.
            
            giMovementSlotsUsed++;
            
			// Get the data's slot number.
			
			tInput = parGet(pFile, ' ', '\n', ',');
			iSlot = atoi(tInput.c_str()) - 1;
            
            // Reset any vital data.
            
            movetype[iSlot].Purge();
			
			// Then get the terrain's name.
            
            tInput = parGet(pFile, ' ', '\n', ',');
            movetype[iSlot].tName = tInput;
            
            // Now start processing data
            
            tInput = parGet(pFile, ' ', '\n', ',');        

            while(tInput != "}" && !feof(pFile))
            {            
                // icon
                
                if(tInput == "icon")
                {
                    parNext(pFile);
                    faction[iSlot].mIcon = gfxLoad(parNext(pFile), "attributes");
                }; // end if icon
                
                tInput = parGet(pFile, ' ', '\n', ',');
            }; // end while
        };
        
		// If we ever hit a # comment line, then we want to skip the
		// entire thing. We'll have to handle that locally, so we
		// create a new char variable to deal with it.
		
		if(tInput == "#")
		{
			char cSingle;
            
            cSingle = (char)fgetc(pFile);
			
			while(cSingle != '\n')
			{
				cSingle = (char)fgetc(pFile);
			}; // end while
		}; // end if COMMENTS
	}; // end while
	
	return 0; // Success
};
