#include "stdafx.h"
#include "header.h"

int CClass::Purge (void)
{
    // Clears all the data for this class so that we can insert
    // new class data here. Some of the data is set to something
    // besides zero in case the user forgot to set it so that
    // the engine doesn't choke.

    tName = "";
    
    // Level Data
    
    iMaxLEV = 5;
    iNext = 25;
    iNextGrowth = 15;
    iEXP = 5;
    iEXPGrowth = 10;
    iEXPOffset = 0;
    
    // Attributes, Affinities, and Types
    
    iType = 0;
    
    for (int i=0; i < 9; i++)
        bProperties[i] = false;
    
    // Animation
    
    for (int i=0; i < 9; i++)
        iFrames[i] = 4;
    
    bNoAnim = false;
    iSpeed = 2;

    // Basic Attack Data
    
    bNoCounter = false;
    bNoRunAndGun = false;
    iNear = 0;
    iRange = 0;
    
    // Base Stats
    
    iBHP = 10;
    iBSTR = 0;    
    iBCON = 0;
    iBDEX = 0;
    iBMAG = 0;
    iBRES = 0;
    iBAGL = 0;
    iBSPD = 0;
    iBLUK = 0;
    iBBLD = 0;
    iBMOV = 5;
    
    // Items
    
    iSlots = 5;
    
    for (int i = 0; i < giMaxSlots; i++)
    {
        tItem[i] = "!NULL";
    };
    
    return 0; // Done
};

int classLoad(string tFile)
{
	// A routine for parsing class data from a file.
	
	FILE * pFile;					// A pointer to the file.
	string tInput;					// Input from the parser.
	
	// First, we need to make sure the file is actually there. In the future,
	// if it's missing, we fall back on the default class data. For now, we
	// just boot the player. :3
	
	if(!exists(tFile.c_str()))
	{
		allegro_message("The class data that the engine needs appears to be missing.");
		exit(-1);
	}; //end if
	
	// Okay, let's start by clearing out essential old class data. Everything else
	// we can pretty much clear as we go.
	
	giClassSlotsUsed = 0;
	
	// We can now open the file...
	
	pFile = fopen(tFile.c_str(), "rt");
	
	// ...And begin parsing the data. We keep going until we hit the end
	// of the rainbow (or the file, whichever comes first).
	
	while(!feof(pFile))
	{
		// First get the next command.
		
		tInput = parGet(pFile, ' ', '\n', ',');
		
		// CLASS
		
		if(tInput == "CLASS")
		{
			int iSlot = 0;				// The slot number this class will take.
			
            // Increase the total number of classes by one.
            
            giClassSlotsUsed++;
            
			// Get the class's slot number
			
			tInput = parGet(pFile, ' ', '\n', ',');
			iSlot = atoi(tInput.c_str());
            
            // Reset any vital data.
            
            rank[iSlot].Purge();
			
			// Then the class's name.
            
            tInput = parGet(pFile, ' ', '\n', ',');
            rank[iSlot].tName = tInput;
            rank[iSlot].tHandle = rank[iSlot].tName;
            
            // Now start processing data
            
            tInput = parGet(pFile, ' ', '\n', ',');
            
            while(tInput != "}" && !feof(pFile))
            {

                if(tInput == "handle")
                {
                    tInput = parNext(pFile);
                    rank[iSlot].tHandle = tInput;
                } // end if

                // Spite Data
                
                if(tInput == "sprite")
                {
                    // Load the requested sprite.
                    
                    tInput = parGet(pFile, ' ', '\n', ',');
                    rank[iSlot].mUnit = gfxLoad(tInput, "units");
                    colorReplace(rank[iSlot].mUnit, makecol(255, 128, 255), makecol(255, 0, 255));
                } // end if
                
                if(tInput == "type")
                {
                    rank[iSlot].iType = movetypeFind(parNext(pFile));
                };
                
                // Attribute Data

                /*if(tInput == "ATTRIBUTES")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "movetype")
                        {
                            parNext(pFile);
                            rank[iSlot].bNoAnim = true;
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                }*/ // end if
                
                // LEVELS data
                
                if(tInput == "LEVELS")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "max")
                        {
                            parNext(pFile);
                            rank[iSlot].iMaxLEV = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "next")
                        {
                            parNext(pFile);
                            rank[iSlot].iNext = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "next_growth")
                        {
                            parNext(pFile);
                            rank[iSlot].iNextGrowth = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "exp")
                        {
                            parNext(pFile);
                            rank[iSlot].iEXP = atoi(parNext(pFile).c_str());
                        };                        
                        
                        if(tInput == "exp_growth")
                        {
                            parNext(pFile);
                            rank[iSlot].iEXPGrowth = atoi(parNext(pFile).c_str());
                        };
                        
                        if(tInput == "offset")
                        {
                            parNext(pFile);
                            rank[iSlot].iEXPOffset = atoi(parNext(pFile).c_str());
                        };
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end LEVELS          
                
                // Animation Data

                if(tInput == "ANIMATION")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "disable")
                        {
                            rank[iSlot].bNoAnim = true;
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end if
                
                // Basic Attack Data

                if(tInput == "ATTACK")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {                        
                        if(tInput == "disable")
                        {
                            tInput = parNext(pFile);
                            if(tInput == "run_and_gun")
                            {
                                rank[iSlot].bNoRunAndGun = true;
                            };
                            if(tInput == "counter")
                            {
                                rank[iSlot].bNoCounter = true;
                            };
                        };
                    
                        if(tInput == "range")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iNear = atoi(tInput.c_str());
                            tInput = parGet(pFile, ' ', '\n', ',');
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iRange = atoi(tInput.c_str()) - rank[iSlot].iNear;
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end if
                
                // Base Stats Data
                
                if(tInput == "BASE_STATS")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "hp")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBHP = atoi(tInput.c_str());
                        };
                        
                        if(tInput == "str")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBSTR = atoi(tInput.c_str());
                        };

                        if(tInput == "con")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBCON = atoi(tInput.c_str());
                        };

                        if(tInput == "agl")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBAGL = atoi(tInput.c_str());
                        };

                        if(tInput == "luk")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBLUK = atoi(tInput.c_str());
                        };                        

                        if(tInput == "mov")
                        {
                            tInput = parGet(pFile, ' ', '\n', ',');
                            rank[iSlot].iBMOV = atoi(tInput.c_str());
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    }; // end while
                }; // end if
                
                // Skill Data

                if(tInput == "SKILLS")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "type")
                        {
                            int iToSet = skillGet(parNext(pFile));
                            if(iToSet >= 0 && iToSet < giMaxSkills)
                                rank[iSlot].iSkill[iToSet] = atoi(parNext(pFile).c_str());
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end if 

                // Item Data

                if(tInput == "ITEMS")
                {
                    int iItemSlot = 0;
                    
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "active")
                        {
                            rank[iSlot].bSlotActive[iItemSlot] = true;
                            tInput = parGet(pFile, ' ', '\n', ',');                            
                            rank[iSlot].tItem[iItemSlot] = tInput;
                            iItemSlot++;
                        }
                        
                        if(tInput == "inactive")
                        {
                            rank[iSlot].bSlotActive[iItemSlot] = false;
                            tInput = parGet(pFile, ' ', '\n', ',');                            
                            rank[iSlot].tItem[iItemSlot] = tInput;
                            iItemSlot++;
                        }                        
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end if                 
                
                // Get the next command, and then loop back around.
                
                tInput = parGet(pFile, ' ', '\n', ',');
            }; // end while
		};// end if CLASS

		// If we ever hit a # comment line, then we want to skip the
		// entire thing. We'll have to handle that locally, so we
		// create a new char variable to deal with it.
		
		if(tInput == "#")
		{
			char cSingle;
            
            cSingle = (char)fgetc(pFile);
			
			while(cSingle != '\n')
			{
				cSingle = (char)fgetc(pFile);
			}; // end while
		}; // end if COMMENTS
	}; // end while
	
	return 0; // Success
};
