#include "stdafx.h"
#include "header.h"

int CItem::Purge (void)
{
    // Clears all the data for this item, getting it ready
    // for a new rule set or campaign.

    //mIcon = gfxLoad("!Null", "Root");
    
    tName = "???";
    tHandle = "";
    tType = "";
    tIcon = "!Null";

    iAcc = 0;
    iClass = 0;
    iPower = 0;
    iUses = 0;
    iWeight = 0;
    
    return 0; // Done
}

int itemGet (string tHandle)
{
    // Looks up an item's handle name and returns its slot ID.
    // Returns -1 on failure.
    
    for(int i = 0; i < giMaxItems; i++)
    {
        if(item[i].tHandle == tHandle)
            return i;
    }
    
    return -1;
}

int itemLoad (string tFile)
{
	// A routine for parsing item data from a file.
	
	FILE * pFile;					// A pointer to the file.
	string tInput;					// Input from the parser.
	
	// First, we need to make sure the file is actually there.
	
	if(!exists(tFile.c_str()))
	{
		allegro_message("The item data that the engine needs appears to be missing.");
		exit(-1);
	} //end if
	
	// Clear out old crud.
	
	giTotalItems = 0;
	
	// We can now open the file.
	
	pFile = fopen(tFile.c_str(), "rt");
	
	// We keep going until we hit the end of the file.
	
	while(!feof(pFile))
	{
		// First get the next command.
		
		tInput = parGet(pFile, ' ', '\n', ',');
		
		// TYPE
		
		if(tInput == "WEAPON" || tInput == "CONSUMABLE" || tInput == "ACCESSORY"
            || tInput == "SUPPLEMENT" || tInput == "PROP")
		{
			int iSlot = giTotalItems;			// The slot number this type will take.
			
            // Increase the total number of types by one.
            
            giTotalItems++;
            
            // Reset any old data.
            
            item[iSlot].Purge();
            
            // Record what catagory of item this is.
            
            if(tInput == "PROP")
                item[iSlot].iClass = giItemProp;
            else if(tInput == "WEAPON")
                item[iSlot].iClass = giItemWeapon;
            else if(tInput == "CONSUMABLE")
                item[iSlot].iClass = giItemConsumable;
            else if(tInput == "ACCESSORY")
                item[iSlot].iClass = giItemAccessory;
            else if(tInput == "SUPPLEMENT")
                item[iSlot].iClass = giItemSupplement;
			
			// Then get the items's name.
            
            tInput = parGet(pFile, ' ', '\n', ',');
            item[iSlot].tName = tInput;
            item[iSlot].tHandle = item[iSlot].tName;
            
            // Now start processing data
            
            tInput = parGet(pFile, ' ', '\n', ',');
            
            while(tInput != "}" && !feof(pFile))
            {   
                // handle
                
                if(tInput == "handle")
                {                    
                    tInput = parNext(pFile);
                    item[iSlot].tHandle = tInput;
                } // end if
                
                // Icon Data
                
                if(tInput == "icon")
                {
                    // Load the requested sprite.
                    
                    tInput = parNext(pFile);
                    tInput = parNext(pFile);
                    item[iSlot].tIcon = tInput;
                    //item[iSlot].mIcon = gfxLoad(tInput, "items");
                } // end if
                
                // PROPERTIES data
                
                if(tInput == "PROPERTIES")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "pow")
                        {
                            parNext(pFile);
                            item[iSlot].iPower = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "hit")
                        {
                            parNext(pFile);
                            item[iSlot].iAcc = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "wgt")
                        {
                            parNext(pFile);
                            item[iSlot].iWeight = atoi(parNext(pFile).c_str());
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end LEVELS
                
                // Get the next command, and then loop back around.
                
                tInput = parGet(pFile, ' ', '\n', ',');
            }; // end while
		};// end if CLASS

		// If we ever hit a # comment line, then we want to skip the
		// entire thing. We'll have to handle that locally, so we
		// create a new char variable to deal with it.
		
		if(tInput == "#")
		{
			char cSingle;
            
            cSingle = (char)fgetc(pFile);
			
			while(cSingle != '\n')
			{
				cSingle = (char)fgetc(pFile);
			}; // end while
		}; // end if COMMENTS
	}; // end while
	
	return 0; // Success
};
