// ITEM DATA CLASS
//
// Item data and all its related variables, routines, etc.
//
// IMPORTANT: If you add any variables to the data structure, make sure
// you add them to the Clear routines.

const int giMaxItems = 500;

const int giItemProp = 0;
const int giItemWeapon = 1;
const int giItemAccessory = 2;
const int giItemSupplement = 3;
const int giItemConsumable = 4;

class CItem
{
public:
    int Purge (void);               // Deletes all data from this item.
    
    //BITMAP *mIcon;                  // The image containing the icons for this item.
	
    int iAcc;                       // This item's accuracy rating.
    int iClass;                     // What class of item this is (weapon, prop, etc).
    int iPower;                     // This item's attack power.
    int iUses;                      // How many times the item can be used before being used up.
    int iWeight;                    // This item's weight.
	
    string tHandle;                 // The handle name for this item.
    string tIcon;                   // Filename of this item's icon.
    string tName;                   // This item's name.
    string tType;                   // What type of item this is; what skill is required to wield it.
};
