#include "stdafx.h"
#include "header.h"

const int STAT_PROFILE = 0;
const int STAT_STATS = 1;
const int STAT_SKILLS = 2;

int CMainLoop::Display_ (void)
{
    // Run the Display
    
    if(iStatWindow == -1)
    {
        map.Display(iOffsetX, iOffsetY, iOffsetXX, iOffsetYY, false, 0);
        unitUpdate();
        
        // Go square by square and display units and flags.
        
        for(int x = iOffsetX - 1; x < iOffsetX + giTilesWide + 1; x++)
        {
            for(int y = iOffsetY - 1; y < iOffsetY + giTilesHigh + 1; y++)
            {
                // Display flags first.
                    
                if(map.iFlag[x][y] != -1 && map.iFlagType[x][y] == 0)
                    draw_sprite(mBuffer, faction[map.iFlag[x][y]].mBanner, (x * giTileX) - giUnitOffsetX - (iOffsetX * giTileX) + iOffsetXX, (y * giTileY) - giUnitOffsetY - (iOffsetY * giTileX) + iOffsetYY);
                    
                for(int i = 0; i < giMaxUnits; i++)
                {                    
                    // And units above them.
                    
                    if(unit[i].bActive && unit[i].iLocX == x && unit[i].iLocY == y)
                    {
                        int iHPLength = 0;
                        
                        if(unit[i].iHPBar == unit[i].iMaxHP)
                            iHPLength = 20;
                        else
                        {
                            iHPLength = (unit[i].iHPBar * 20) / unit[i].iMaxHP;
                        };
                        
                        if(rank[unit[i].iClass].bNoAnim)
                            masked_blit(unit[i].mImage, mBuffer, giUnitSourceX, giUnitSourceY + (giUnitHeight*0),
                                (unit[i].iX - iOffsetX * 32) - giUnitOffsetX + iOffsetXX, (unit[i].iY - iOffsetY*32) - giUnitOffsetY + iOffsetYY, giUnitWidth, giUnitHeight);                            
                        else
                            masked_blit(unit[i].mImage, mBuffer, giUnitSourceX + (giUnitWidth * giUnitBob[0]), giUnitSourceY + (giUnitHeight*0),
                                (unit[i].iX - iOffsetX * 32) - giUnitOffsetX + iOffsetXX, (unit[i].iY - iOffsetY*32) - giUnitOffsetY + iOffsetYY, giUnitWidth, giUnitHeight);
                        masked_blit(mHP, mBuffer, 0, 0, (unit[i].iX - iOffsetX * 32) + 24 + iOffsetXX, (unit[i].iY - iOffsetY * 32) - 2 + iOffsetYY, 8, 24);
                        masked_blit(mHP, mBuffer, 8, 22 - iHPLength, (unit[i].iX - iOffsetX * 32) + 24 + iOffsetXX, (unit[i].iY - iOffsetY * 32) - iHPLength + 20 + iOffsetYY, 8, iHPLength);                        
                        draw_sprite(mBuffer, faction[unit[i].iFaction].mIcon, (unit[i].iX - iOffsetX * 32) + 20 + iOffsetXX, (unit[i].iY - iOffsetY * 32) + 20 + iOffsetYY);
                    };
                };
            };
        };
        
        // Draw unit paths as neccisary (you should only need to draw one path at a time.)
      
        if(!unitMoving())
        {
            for(int i = 0; i < giMaxUnits; i++)
            {
                if(unit[i].bActive == true && unit[i].vPath.size() > 1)
                {
                    for(unsigned j = 0; j < unit[i].vPath.size(); j++)
                    {
                        int iArrowGFX = 0;
                        int iThisX = unit[i].vPath[j].iX;
                        int iThisY = unit[i].vPath[j].iY;                
                        
                        if(j > 0 && j < unit[i].vPath.size() - 1)
                        {
                            int iPastX = unit[i].vPath[j - 1].iX;
                            int iPastY = unit[i].vPath[j - 1].iY;
                            int iNextX = unit[i].vPath[j + 1].iX;
                            int iNextY = unit[i].vPath[j + 1].iY;
                            
                            if(iThisX > iPastX && iThisY == iPastY && iThisX < iNextX && iThisY == iNextY
                                || iThisX < iPastX && iThisY == iPastY && iThisX > iNextX && iThisY == iNextY)
                                iArrowGFX = 6;
                            else if(iThisX == iPastX && iThisY > iPastY && iThisX == iNextX && iThisY < iNextY
                                || iThisX == iPastX && iThisY < iPastY && iThisX == iNextX && iThisY > iNextY)
                                iArrowGFX = 5;
                            else if(iThisX > iPastX && iThisY == iPastY && iThisX == iNextX && iThisY > iNextY
                                || iThisX == iPastX && iThisY > iPastY && iThisX > iNextX && iThisY == iNextY)
                                iArrowGFX = 7;
                            else if(iThisX == iPastX && iThisY > iPastY && iThisX < iNextX && iThisY == iNextY
                                || iThisX < iPastX && iThisY == iPastY && iThisX == iNextX && iThisY > iNextY)
                                iArrowGFX = 8;
                            else if(iThisX < iPastX && iThisY == iPastY && iThisX == iNextX && iThisY < iNextY
                                || iThisX == iPastX && iThisY < iPastY && iThisX < iNextX && iThisY == iNextY)
                                iArrowGFX = 9;
                            else if(iThisX > iPastX && iThisY == iPastY && iThisX == iNextX && iThisY < iNextY
                                || iThisX == iPastX && iThisY < iPastY && iThisX > iNextX && iThisY == iNextY)
                                iArrowGFX = 10;
                        }
                        else if (j > 0)
                        {
                            int iPastX = unit[i].vPath[j - 1].iX;
                            int iPastY = unit[i].vPath[j - 1].iY;
                            
                            if(iThisX < iPastX)
                                iArrowGFX = 1;
                            if(iThisY < iPastY)
                                iArrowGFX = 2;
                            if(iThisX > iPastX)
                                iArrowGFX = 3;
                            if(iThisY > iPastY)
                                iArrowGFX = 4;        
                        }
                        else if (j == 0)
                        {
                            int iNextX = unit[i].vPath[j + 1].iX;
                            int iNextY = unit[i].vPath[j + 1].iY;
                            
                            if(iThisX < iNextX)
                                iArrowGFX = 13;
                            if(iThisY < iNextY)
                                iArrowGFX = 14;
                            if(iThisX > iNextX)
                                iArrowGFX = 11;
                            if(iThisY > iNextY)
                                iArrowGFX = 12;
                        };
                        
                        masked_blit(mArrows, mBuffer, iArrowGFX * giTileX, 0, (unit[i].vPath[j].iX - iOffsetX) * giTileX + iOffsetXX, (unit[i].vPath[j].iY - iOffsetY) * giTileY + iOffsetYY, giTileX, giTileY);
                    };
                };
            };
        };
    
        // Display any messages.
        
        msg.Display(iOffsetX * giTileX, iOffsetY * giTileY);
        
        // Highlight the square that the player is hovering over.
        
        drawing_mode(DRAW_MODE_TRANS, 0, 0, 0);
        if(!playerBusy() && iFade == 0)
            rectfill(mBuffer, iXPos, iYPos, iXPos + giTileX - 1, iYPos + giTileY - 1, makecol(255, 255, 255));        
        solid_mode(); 

        // Display this faction's header window
        
        if(mouse_x < 224)
            iHeader = 464;
        else if(mouse_x > 415)
            iHeader = 0;
            
        if(iFade == 0 && bHeaderOn)
        {
            draw_sprite(mBuffer, faction[iFaction].mHeader, iHeader, 0);
            txtCenter(2, iHeader + 88, 112, faction[iFaction].tName + "/n "
                + txt.Get("gold") + txtInt(faction[iFaction].iMoney) + "/n "
                + txt.Get("units") + txtInt(faction[iFaction].iUnits) + "/n "
                + txt.Get("flags") + txtInt(faction[iFaction].iFlags), 0, -1);
        }
        
        // Perform the turn opening animation
        
        if(iFade != 0)
        {
            int iFadeAt = iFade;
            int iLeaderAt = ((iFade * -1) + 75) * 15;

            if(iFadeAt > 127)
                iFadeAt = 127;
            if(iLeaderAt < 0)
                iLeaderAt = 0;            
            
            set_trans_blender(0, 0, 0, iFadeAt + iFadeAt/2);
            drawing_mode(DRAW_MODE_TRANS, 0, 0, 0);
            //rectfill(mBuffer, 0, 0, 640, 100, giColorChart[iFaction + 1][2]);
            //rectfill(mBuffer, 0, 380, 640, 480, giColorChart[iFaction + 1][2]);
            rectfill(mBuffer, 0, 150, 640, 330, giColorChart[faction[iFaction].iColor][2]);
            //rectfill(mBuffer, 0, 0, 640, 480, giColorChart[iFaction + 1][2]);
            //txtCenter(2, 320, 200, txt.Get("faction") + " " + txtInt(iFaction), 0, -1);
            solid_mode();
            set_trans_blender(0, 0, 0, 127); // Return the trans_blender back to default.            
            draw_sprite(mBuffer, faction[iFaction].mLeaderFull, iLeaderAt, 0);
            txtCenter(5, 320, 224, faction[iFaction].tName + " " + txt.Get("phase"), 0, -1);
            txtCenter(2, 320, 260, txtInt(faction[iFaction].iUnits) + " " + txt.Get("left"), 0, -1);
            if(faction[iFaction].iFlags != -1)
                txtCenter(2, 320, 280, txtInt(faction[iFaction].iFlags) + " " + txt.Get("flagsleft"), 0, -1);
        };
    }
    else
    {
        DisplayStats_();
    };
    
    displayAll();
        
    return 0; // Done
};

int CMainLoop::DisplayStats_ (void)
{
    // Displays the stat screen of a unit.
        
    blit(mStatBG[0], mBuffer, 0, 0, 0, 0, sys_iScreenWidth, sys_iScreenHeight);
    draw_sprite(mBuffer, faction[unit[iStatWindow].iFaction].mLeaderFull, 0, 0);
    masked_blit(mStatBG[1], mBuffer, 0, 0, 0, 0, sys_iScreenWidth, sys_iScreenHeight);
    
    txtOut(5, 2 *16, 1 *16, unit[iStatWindow].tName, 0, -1);
    //txtCenter(5, 8 *16, 16 *16, unit[iStatWindow].tName, 0, -1);
    txtOut(2, 3 *16, 52, rank[unit[iStatWindow].iClass].tName, 0, -1);
    //txtOut(2, 3 *16, 52, movetype[rank[unit[iStatWindow].iClass].iType].tName, 0, -1);
    
    txtOut(2, 4 *16, 20 *16, txt.Get("LEV"), 0, -1);
       txtRight(5, 9 *16, 19 *16, txtInt(unit[iStatWindow].iLev), 0, -1);
       txtOut(2, 10 *16, 20 *16, "/ " + txtInt(rank[unit[iStatWindow].iClass].iMaxLEV), 0, -1);
    txtOut(2, 4 *16, 22 *16, txt.Get("HP"), 0, -1);
       txtRight(5, 9 *16, 21 *16, txtInt(unit[iStatWindow].iHP), 0, -1);
       txtOut(2, 10 *16, 22 *16, "/ " + txtInt(unit[iStatWindow].iMaxHP), 0, -1);
    txtOut(2, 4 *16, 24 *16, txt.Get("MP"), 0, -1);
       txtRight(5, 9 *16, 23 *16, txtInt(unit[iStatWindow].iMP), 0, -1);
       txtOut(2, 10 *16, 24 *16, "/ " + txtInt(unit[iStatWindow].iMaxMP), 0, -1);
    txtOut(2, 4 *16, 26 *16, txt.Get("EXP"), 0, -1);
       txtRight(5, 9 *16, 25 *16, txtInt(unit[iStatWindow].iEXP), 0, -1);
       txtOut(2, 10 *16, 26 *16, "/ " + txtInt(unit[iStatWindow].iNext), 0, -1);

    if(iStatPage == STAT_PROFILE)
    {        
        masked_blit(mStatBG[3], mBuffer, 0, 0, 0, 0, sys_iScreenWidth, sys_iScreenHeight);
        
        txtOut(5, 17 *16, 6 *16, txt.Get("profile"), 0, -1);
        
        txtOut(2, 18 *16, 9 *16, unit[iStatWindow].tDescription + "/n /n " +
            rank[unit[iStatWindow].iClass].tDescription, 18 *16, -1);
    }        
    else if(iStatPage == STAT_STATS)
    {
        masked_blit(mStatBG[2], mBuffer, 0, 0, 0, 0, sys_iScreenWidth, sys_iScreenHeight);
        
        //txtCenter(5, 28 *16, 6 *16, "Unit Stats", 0, -1);
        txtOut(5, 17 *16, 6 *16, txt.Get("stats"), 0, -1);
        txtOut(2, 18 *16, 10 *16, txt.Get("STR"), 0, -1);
          txtRight(5, 25 *16, 9 *16, txtInt(unit[iStatWindow].iSTR), 0, -1);
        txtOut(2, 29 *16, 10 *16, txt.Get("MAG"), 0, -1);
          txtRight(5, 36 *16, 9 *16, txtInt(unit[iStatWindow].iMAG), 0, -1);
        txtOut(2, 18 *16, 12 *16, txt.Get("DEX"), 0, -1);
          txtRight(5, 25 *16, 11 *16, txtInt(unit[iStatWindow].iDEX), 0, -1);
        txtOut(2, 29 *16, 12 *16, txt.Get("CON"), 0, -1);
          txtRight(5, 36 *16, 11 *16, txtInt(unit[iStatWindow].iCON), 0, -1);
        txtOut(2, 18 *16, 14 *16, txt.Get("RES"), 0, -1);
          txtRight(5, 25 *16, 13 *16, txtInt(unit[iStatWindow].iRES), 0, -1);
        txtOut(2, 29 *16, 14 *16, txt.Get("SPD"), 0, -1);
          txtRight(5, 36 *16, 13 *16, txtInt(unit[iStatWindow].iSPD), 0, -1);          
        txtOut(2, 18 *16, 16 *16, txt.Get("AGL"), 0, -1);
          txtRight(5, 25 *16, 15 *16, txtInt(unit[iStatWindow].iAGL), 0, -1);
        txtOut(2, 29 *16, 16 *16, txt.Get("LUK"), 0, -1);
          txtRight(5, 36 *16, 15 *16, txtInt(unit[iStatWindow].iLUK), 0, -1);          
        txtOut(2, 18 *16, 18 *16, txt.Get("BLD"), 0, -1);
          txtRight(5, 25 *16, 17 *16, txtInt(unit[iStatWindow].iBLD), 0, -1);
        txtOut(2, 29 *16, 18 *16, txt.Get("MOV"), 0, -1);
          txtRight(5, 36 *16, 17 *16, txtInt(unit[iStatWindow].iMOV), 0, -1);                    
    
        txtOut(2, 18 *16, 24 *16, txt.Get("might"), 0, -1);
          txtRight(5, 25 *16, 23 *16, txtInt(unit[iStatWindow].iSTR), 0, -1);
        txtOut(2, 29 *16, 24 *16, txt.Get("hitstat"), 0, -1);
          txtRight(5, 36 *16, 23 *16, txtInt(unitHit(iStatWindow)), 0, -1);
        txtOut(2, 18 *16, 26 *16, txt.Get("avoid"), 0, -1);
          txtRight(5, 25 *16, 25 *16, txtInt(unitAvoid(iStatWindow)), 0, -1);
        txtOut(2, 29 *16, 26 *16, txt.Get("crit"), 0, -1);
          txtRight(5, 36 *16, 25 *16, txtInt(0), 0, -1);          
    }
    else if(iStatPage == STAT_SKILLS)
    {
        int iRow = 0; // This is the row that we need to display the next skill at.
        
        masked_blit(mStatBG[3], mBuffer, 0, 0, 0, 0, sys_iScreenWidth, sys_iScreenHeight);
        
        txtOut(5, 17 *16, 6 *16, txt.Get("skills"), 0, -1);
        
        // Go through all the skills, and display the ones that this unit possesses.
        for(int i = 0; i < giTotalSkills; i++)
        {
            if(unit[iStatWindow].iSkill[i] > 0 && !skill[i].bHidden)
            {
                draw_sprite(mBuffer, mStatBG[4], 17 *16, (9+iRow*2) *16);
                draw_sprite(mBuffer, skill[i].mIcon, 17 *16, (9+iRow*2) *16);
                
                txtOut(2, 20 *16, (10+iRow*2) *16, skill[i].tNamePlural, 0, -1);
                txtRight(5, 34 *16, (9+iRow*2) *16, txtInt(unit[iStatWindow].iSkill[i]), 0, -1);
                txtRight(2, 36 *16, (10+iRow*2) *16, "/ " + txtInt(skill[i].iMaxLevel), 0, -1);
                
                iRow++;
            }
        }
    }
      
    if(mouseClick(1))
    {
        iStatPage++;
        if(iStatPage > 2)
            iStatPage = 0;
    }
    if(mouseClick(2))
    {
        iStatWindow = -1;
    }
    
    return 0; // Done
}
