class CMainLoop
{
public:
    int Main (void);
    int SetupMap (void);
    
    bool bHeaderOn;         // Whether or not the header should be displayed.
    
    int iHeader;            // Where the current faction's header is on the screen.
private:
    int Display_ (void);
    int DisplayStats_ (void);
    int FactionCheck_ (void);
    int FindMouse_ (void);
    int MoveMap_ (int iDirection);
    int ScrollMap_ (void);
    int SetUnit_ (int iUnit, int x, int y);
    int TurnStart_ (void);
    
    BITMAP *mArrows;        // The movement arrows.
    BITMAP *mHP;            // The HP bar.
    BITMAP *mFullbody;      // Full-body portrait of a given unit.
    BITMAP *mStatBG[5];     // The status screen backgrounds.
    BITMAP *mPreBattle[2];  // The pre-battle information screens.
    
    bool bTurnHasStarted;   // Whether or not the phase intro animation has completed and the faction's turn has begun.
    bool bQuit;             // True when the main loop is finished.
    
    int iFade;              // How opaque the color fade at the beginning of a faction's turn is right now.
    int iFadeSpeed;         // How quickly the fade is to occure.
    int iFaction;           // Who's turn it is.
	int iOffsetX;			// How far from the map's X origin the screen is.
	int iOffsetY;			// How far from the map's X origin the screen is.
	int iOffsetXX;			// An additional pixel offset to add to OffsetX to give a true scrolling effect.
	int iOffsetYY;			// An additional pixel offset to add to OffsetY to give a true scrolling effect.
	int iScrollSpeed;		// How quickly to scroll the screen.
    int iStatPage;          // Which page of the stat window is being viewed.
    int iStatWindow;        // The stat window for this unit is up.
    int iWinner;            // Which team has won this map; the value that the main loop will return.
	int iX;					// The X Location of the Tile that the mouse is currently hovering over.
	int iY;					// The Y Location of the Tile that the mouse is currently hovering over.
	int iXPos;				// The exact location on the screen of the tile that the mouse is hovering over on the screen.
	int iYPos;				// The exact location on the screen of the tile that the mouse is hovering over on the screen.
};
