#include "stdafx.h"
#include "header.h"

int rulesetLoad (string tPath)
{
    guiLoading();
    map.tRuleSet = tPath;
    sys_tPath = sys_tRuleSetPath + tPath + "/";
    
    // Set GUI elements
    
    mouseGFX("pointer_01");
    colorGet();
    
    // Parse data files
    
    rulesetLoadRules(sys_tPath + sys_tDataPath + "rules.data");
    musicLoad(sys_tPath + sys_tDataPath + "bgm.data");
    //attributeLoad(sys_tPath + sys_tDataPath + "attribute.data");
    movetypeLoad(sys_tPath + sys_tDataPath + "movement.data");
    skillLoad(sys_tPath + sys_tDataPath + "skills.data");
    itemLoad(sys_tPath + sys_tDataPath + "items.data");
	classLoad(sys_tPath + sys_tDataPath + "class.data");
    terrainLoad(sys_tPath + sys_tDataPath + "terrain.data");
    factionLoad(sys_tPath + sys_tDataPath + "faction.data");
    
    return 0; // Success
};

int rulesetLoadRules (string tFile)
{
	// A routine for parsing general rule set data from a file.
	
	FILE * pFile;					// A pointer to the file.
	string tInput;					// Input from the parser.
	
	// First, we need to make sure the file is actually there. In the future,
	// if it's missing, we'll... Do something else. I don't know what yet. For
	// now, we'll just boot the player.
	
	if(!exists(tFile.c_str()))
	{
		allegro_message("The general rule set or campaign data that the engine needs appears to be missing.");
		exit(-1);
	}; //end if
	
	// Okay, let's start by clearing out major faction data. Everything else
	// we can pretty much clear as we go.
    
    rule.tTitle = "(None?)";
    rule.tAuthor = "Unknown";
    rule.tVersion = "N/A";
    
    // Now open the file.
    
	pFile = fopen(tFile.c_str(), "rt");
	
	// ...And begin parsing the data. We keep going until we hit the end of the file.
	
	while(!feof(pFile))
	{
		// First get the next command.
		
		tInput = parNext(pFile);
        
        // Rule Set Name
        
        if(tInput == "title")
        {
            parNext(pFile);
            rule.tTitle = parNext(pFile);
        };

        // Author Name
        
        if(tInput == "author")
        {
            parNext(pFile);
            rule.tAuthor = parNext(pFile);
        };
        
        // Version
        
        if(tInput == "version")
        {
            parNext(pFile);
            rule.tVersion = parNext(pFile);
        };        
    };
    
    return 0; // Success
};
