#include "stdafx.h"
#include "header.h"

int CSkill::Purge (void)
{
    // Clears all the data for this class, getting it ready
    // for a new rule set or campaign.

    mIcon = gfxLoad("!Null", "Root");
    
    tName = "";
    tHandle = "";
    tNamePlural = "";

    bActivation = false;
    bHidden = false;
    bMultiEquip = false;
    bRated = true;
    
    iExpNext = 15;
    iExpNextGrow = 9;
    iMaxLevel = 5;
    iToLearn = 30;
    
    return 0; // Done
}

int skillGet (string tHandle)
{
    // Looks up a skill's handle name and returns its slot ID.
    // Returns -1 on failure.
    
    for(int i = 0; i < giMaxSkills; i++)
    {
        if(skill[i].tHandle == tHandle)
            return i;
    }
    
    return -1;
}

int skillLoad (string tFile)
{
	// A routine for parsing skill ype data from a file.
	
	FILE * pFile;					// A pointer to the file.
	string tInput;					// Input from the parser.
	
	// First, we need to make sure the file is actually there.
	
	if(!exists(tFile.c_str()))
	{
		allegro_message("The skill type data that the engine needs appears to be missing.");
		exit(-1);
	} //end if
	
	// (Yawn.) Start by clearing out essential old type data. Yadda Yadda.
	
	giTotalSkills = 0;
	
	// We can now open the file.
	
	pFile = fopen(tFile.c_str(), "rt");
	
	// We keep going until we hit the end of the file.
	
	while(!feof(pFile))
	{
		// First get the next command.
		
		tInput = parGet(pFile, ' ', '\n', ',');
		
		// TYPE
		
		if(tInput == "SKILL")
		{
			int iSlot = giTotalSkills;			// The slot number this type will take.
			
            // Increase the total number of types by one.
            
            giTotalSkills++;
            
            // Reset any old data.
            
            skill[iSlot].Purge();
			
			// Then the skill's name.
            
            tInput = parGet(pFile, ' ', '\n', ',');
            skill[iSlot].tName = tInput;
            skill[iSlot].tHandle = skill[iSlot].tName;
            
            // Now start processing data
            
            tInput = parGet(pFile, ' ', '\n', ',');
            
            while(tInput != "}" && !feof(pFile))
            {   
                // handle
                
                if(tInput == "handle")
                {                    
                    tInput = parNext(pFile);
                    skill[iSlot].tHandle = tInput;
                } // end if
                
                // Plural Name
                
                if(tInput == "plural")
                {                    
                    tInput = parNext(pFile);
                    skill[iSlot].tNamePlural = tInput;
                } // end if
                
                // Icon Data
                
                if(tInput == "icon")
                {
                    // Load the requested sprite.
                    
                    tInput = parNext(pFile);
                    skill[iSlot].mIcon = gfxLoad(tInput, "skills");
                } // end if

                // Enable/Disable Properties
                
                if(tInput == "enable" || tInput == "disable")
                {
                    bool bSetTo = false;
                    
                    if(tInput == "enable")
                        bSetTo = true;
                    
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    if(tInput == "activation")
                    {
                        skill[iSlot].bActivation = bSetTo;
                    };
                    
                    if(tInput == "growth")
                    {
                        skill[iSlot].bRated = bSetTo;
                    };
                    
                    if(tInput == "hiding")
                    {
                        skill[iSlot].bHidden = bSetTo;
                    };
                    
                    if(tInput == "multiequip")
                    {
                        skill[iSlot].bMultiEquip = bSetTo;
                    };
                }
                
                // LEVELS data
                
                if(tInput == "LEVELS")
                {
                    tInput = parGet(pFile, ' ', '\n', ',');
                    
                    while(tInput != "}")
                    {
                        if(tInput == "max")
                        {
                            parNext(pFile);
                            skill[iSlot].iMaxLevel = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "next")
                        {
                            parNext(pFile);
                            skill[iSlot].iExpNext = atoi(parNext(pFile).c_str());
                        };

                        if(tInput == "next_growth")
                        {
                            parNext(pFile);
                            skill[iSlot].iExpNextGrow = atoi(parNext(pFile).c_str());
                        };
                        
                        tInput = parGet(pFile, ' ', '\n', ',');
                    };                    
                } // end LEVELS
                
                // Get the next command, and then loop back around.
                
                tInput = parGet(pFile, ' ', '\n', ',');
            }; // end while
		};// end if CLASS

		// If we ever hit a # comment line, then we want to skip the
		// entire thing. We'll have to handle that locally, so we
		// create a new char variable to deal with it.
		
		if(tInput == "#")
		{
			char cSingle;
            
            cSingle = (char)fgetc(pFile);
			
			while(cSingle != '\n')
			{
				cSingle = (char)fgetc(pFile);
			}; // end while
		}; // end if COMMENTS
	}; // end while
	
	return 0; // Success
};
