// TYPE DATA CLASS
//
// Skill type data and all its related variables, routines, etc.
//
// IMPORTANT: If you add any variables to the data structure, make sure
// you add them to the Clear routines.

const int giMaxTypes = 25;

class CSkill
{
public:
    int Purge (void);               // Deletes all data from this skill type.
    
    BITMAP *mIcon;                  // The image containing the icons for this skill type.
	
    bool bActivation;               // If true, this type of item can be activated.
	bool bHidden;                   // If hidden, this type does not display as a skill on the unit stat screen.
    bool bLearnable;                // Whether or not any unit can eventually learn to use this type.
    bool bMultiEquip;               // If true, multiple items of this type can be equiped at one time.
    bool bRated;                    // Whether or not this type gains levels.
    
    int iExpNext;                   // The EXP needed to reach the next level in this skill.
    int iExpNextGrow;               // How much the ExpNext variable grows each level.    
    int iMaxLevel;                  // The highest level you can get in this skill.
    int iToLearn;                   // The amount of Exp needed in order to "learn" this skill type.
	
    string tHandle;                 // The handle name for this type.
    string tName;                   // This skill type's name.
    string tNamePlural;             // Plural version of the name. Because we can.
};
